OpenCL C++ Bindings: cl::Image2DArray Class Reference

OpenCL C++ Bindings

Loading...
Searching...
No Matches
cl::Image2DArray Class Reference

Image interface for arrays of 2D images. More...

`#include <opencl.hpp>`

Inheritance diagram for cl::Image2DArray:

## Public Member Functions
| Image2DArray (const Context &context, cl_mem_flags flags, ImageFormat format, size_type arraySize, size_type width, size_type height, size_type rowPitch, size_type slicePitch, void *host_ptr=nullptr, cl_int *err=nullptr)
| Image2DArray (const Context &context, const vector< cl_mem_properties > &properties, cl_mem_flags flags, ImageFormat format, size_type arraySize, size_type width, size_type height, size_type rowPitch=0, size_type slicePitch=0, void *host_ptr=nullptr, cl_int *err=nullptr)
| Constructs a Image2DArray with specified properties.
| Image2DArray (const cl_mem &imageArray, bool retainObject=false)
| Constructor from cl_mem - takes ownership.
Image2DArray & | operator= (const cl_mem &rhs)
Public Member Functions inherited from cl::Image
template<typename T>
cl_int | getImageInfo (cl_image_info name, T *param) const
| Wrapper for clGetImageInfo().
template<cl_image_info name>
detail::param_traits< detail::cl_image_info, name >::param_type | getImageInfo (cl_int *err=nullptr) const
| Wrapper for clGetImageInfo() that returns by value.
Public Member Functions inherited from cl::Memory
| Memory ()
| Default constructor - initializes to nullptr.
| Memory (const cl_mem &memory, bool retainObject)
| Constructor from cl_mem - takes ownership.
Memory & | operator= (const cl_mem &rhs)
| Assignment operator from cl_mem - takes ownership.
template<typename T>
cl_int | getInfo (cl_mem_info name, T *param) const
| Wrapper for clGetMemObjectInfo().
template<cl_mem_info name>
detail::param_traits< detail::cl_mem_info, name >::param_type | getInfo (cl_int *err=nullptr) const
| Wrapper for clGetMemObjectInfo() that returns by value.
cl_int | setDestructorCallback (void(CL_CALLBACK *pfn_notify)(cl_mem, void *), void *user_data=nullptr)
| Registers a callback function to be called when the memory object is no longer needed.
Public Member Functions inherited from cl::detail::Wrapper< cl_mem >
Wrapper< cl_type > & | operator= (const Wrapper< cl_type > &rhs)
const cl_type & | operator() () const
cl_type | get () const

## Additional Inherited Members
Public Types inherited from cl::detail::Wrapper< cl_mem >
typedef cl_mem | cl_type
Protected Member Functions inherited from cl::Image
| Image ()
| Default constructor - initializes to nullptr.
| Image (const cl_mem &image, bool retainObject=false)
| Constructor from cl_mem - takes ownership.
Image & | operator= (const cl_mem &rhs)
| Assignment from cl_mem - performs shallow copy.
Protected Member Functions inherited from cl::detail::Wrapper< cl_mem >
cl_int | retain () const
cl_int | release () const
Protected Attributes inherited from cl::detail::Wrapper< cl_mem >
cl_type | object_

## Detailed Description

Image interface for arrays of 2D images.

Definition at line 5516 of file opencl.hpp.

## Constructor & Destructor Documentation

## ◆ Image2DArray() [1/4]

cl::Image2DArray::Image2DArray | ( | const Context & | context,
|  | cl_mem_flags | flags,
|  | ImageFormat | format,
|  | size_type | arraySize,
|  | size_type | width,
|  | size_type | height,
|  | size_type | rowPitch,
|  | size_type | slicePitch,
|  | void * | host_ptr = nullptr,
|  | cl_int * | err = nullptr )
| inline

Definition at line 5519 of file opencl.hpp.

## ◆ Image2DArray() [2/4]

cl::Image2DArray::Image2DArray | ( | const Context & | context,
|  | const vector< cl_mem_properties > & | properties,
|  | cl_mem_flags | flags,
|  | ImageFormat | format,
|  | size_type | arraySize,
|  | size_type | width,
|  | size_type | height,
|  | size_type | rowPitch = 0,
|  | size_type | slicePitch = 0,
|  | void * | host_ptr = nullptr,
|  | cl_int * | err = nullptr )
| inline

Constructs a Image2DArray with specified properties.

Wraps clCreateImageWithProperties().

Parameters

  properties | Optional list of properties for the image object and their corresponding values. The non-empty list must end with 0.
  host_ptr | Storage to be used if the CL_MEM_USE_HOST_PTR flag was specified. Note alignment & exclusivity requirements.

Definition at line 5566 of file opencl.hpp.

## ◆ Image2DArray() [3/4]

cl::Image2DArray::Image2DArray | ( |  | ) |
| inline

Definition at line 5598 of file opencl.hpp.

## ◆ Image2DArray() [4/4]

cl::Image2DArray::Image2DArray | ( | const cl_mem & | imageArray,
|  | bool | retainObject = false )
| inlineexplicit

Constructor from cl_mem - takes ownership.

Parameters

  retainObject | will cause the constructor to retain its cl object. Defaults to false to maintain compatibility with earlier versions. See Memory for further details.

Definition at line 5607 of file opencl.hpp.

## Member Function Documentation

## ◆ operator=()

Image2DArray & cl::Image2DArray::operator= | ( | const cl_mem & | rhs | ) |
| inline

Definition at line 5609 of file opencl.hpp.

The documentation for this class was generated from the following file:

- opencl.hpp